#!/bin/sh
BASE_PATH=.
TEST_PATH=${BASE_PATH}/test
MODEL_PATH=${BASE_PATH}/model
INPUT_PATH=${BASE_PATH}/input
OUT_PATH=${TEST_PATH}/out

REPEAT_COUNT=1
TIMEOUT=1000 # // 1000ms
TASK_COUNT=1
MODEL=face_detect
OCM_SIZE=OCM_1M
IN_FILE=data.0.bin
TOP_NUM=0
echo "Usage: ./run_hhb_rgb_test.sh [-m model_name] [-r repeat_cnt]"
echo "For example: ./run_hhb_rgb_test.sh -m mobilenetv1_rgb"
while getopts ":r:t:m:o:i:p:" opt
do
  case $opt in
    r)
    REPEAT_COUNT=$OPTARG
    ;;
    t)
    TIMEOUT=$OPTARG
    ;;
    m)
    MODEL=$OPTARG
    ;;
    o)
    OCM_SIZE=$OPTARG
    ;;
    i)
    IN_FILE=$OPTARG
    ;;
    p)
    TOP_NUM=$OPTARG
    ;;
    ?)
    echo "unsupport parameter!!!"
    exit 1;;
  esac
done
echo "MODEL="${MODEL}, "OCM="${OCM_SIZE}, "REPEAT_COUNT="${REPEAT_COUNT}

rm -rf ${OUT_PATH}/${MODEL}/${OCM_SIZE}; mkdir -p ${OUT_PATH}/${MODEL}/${OCM_SIZE}

${TEST_PATH}/npu_src_test ${MODEL_PATH}/${MODEL}/shl.hhb.bm \
  ${INPUT_PATH}/${MODEL}/${IN_FILE}
